



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Day9  进程同步锁      进程队列         进程池         生产消费模型       进程池       paramike模块</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Day9  进程同步锁      进程队列         进程池         生产消费模型       进程池       paramike模块</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 16:57:56 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>进程同步锁：</h2>
<p>当运行程序的时候，有可能你的程序同时开多个进程，开进程的时候会将多个执行结果打印出来，这样的话打印的信息都是错乱的，怎么保证打印信息是有序的呢？</p>
<p><strong>其实也就是相当于让进程独享资源。</strong></p>
<div>
<pre class="prettyprint linenums"> from multiprocessing import Process,Lock    #引用函数<br />
 import time<br />
 def work(name,mutex):<br />
     mutex.acquire()    #在这里加入锁<br />
     print('task &lt;%s&gt; is runing' %name)<br />
     time.sleep(2)<br />
     print('task &lt;%s&gt; is done' % name)<br />
     mutex.release()    #加完锁以后必须需要解锁

 if __name__ == '__main__':<br />
     mutex=Lock()<br />
     p1=Process(target=work,args=('egon',mutex))<br />
     p2=Process(target=work,args=('alex',mutex))<br />
     p1.start()<br />
     p2.start()<br />
     print('主')</pre>
</div>
<p>比如说模拟抢票的功能：</p>
<p>要先写一个文本&nbsp;&nbsp; ("count":1)&nbsp;&nbsp;&nbsp;就记个数就行</p>
<div>
<pre class="prettyprint linenums"> import json<br />
 import os<br />
 import time<br />
 from multiprocessing import Process,Lock<br />
 def search():<br />
     dic=json.load(open('db.txt'))<br />
     print('\033[32m[%s] 看到剩余票数&lt;%s&gt;\033[0m' %(os.getpid(),dic['count']))<br />
 def get_ticket():<br />
     dic = json.load(open('db.txt'))<br />
     time.sleep(0.5) #模拟读数据库的网络延迟<br />
     if dic['count'] &gt; 0:<br />
         dic['count']-=1<br />
         time.sleep(0.5)  # 模拟写数据库的网络延迟<br />
         json.dump(dic,open('db.txt','w'))<br />
         print('\033[31m%s 购票成功\033[0m' %os.getpid())<br />
 def task(mutex):<br />
     search()<br />
     mutex.acquire()<br />
     get_ticket()<br />
     mutex.release()<br />
 if __name__ == '__main__':<br />
     mutex=Lock()<br />
     for i in range(10):<br />
         p=Process(target=task,args=(mutex,))<br />
         p.start()</pre>
</div>
<hr />
<h2>进程队列：</h2>
<p>共享内存的方式：</p>
<div>
<pre class="prettyprint linenums"> from multiprocessing import Process,Manager,Lock     #Manager共享内存函数

 def task(dic,mutex):<br />
     with mutex:<br />
         dic['count']-=1

 if __name__ == '__main__':<br />
     mutex=Lock()<br />
     m=Manager()<br />
     dic=m.dict({'count':100})<br />
     p_l=[]<br />
     for i in range(100):<br />
         p=Process(target=task,args=(dic,mutex))<br />
         p_l.append(p)<br />
         p.start()

     for p in p_l:<br />
         p.join()<br />
     print(dic)</pre>
</div>
<p>队列：</p>
<p>进程彼此之间隔离，要实现进程间通信</p>
<div>
<pre class="prettyprint linenums"> from multiprocessing import Queue    #引用函数<br />
 q=Queue(3)      #意味着你队列长队最大为三

 q.put('first')<br />
 q.put('second')<br />
 q.put('third')<br />
 # q.put('fourth')    #满了的话会一直卡住

 print(q.get())<br />
 print(q.get())<br />
 print(q.get())<br />
 print(q.get())

 #了解<br />
 # q=Queue(3)<br />
 #<br />
 # q.put('first',block=False)<br />
 # q.put('second',block=False)<br />
 # q.put('third',block=False)    #这样的话队列满了就会抛出异常，不会卡在这里<br />
 # # q.put_nowait('fourth') <br />21 #q.put('fourth',block=False)<br />
 # q.put('fourth',timeout=3)     #指定抛出时间，如果3秒后队列还是满的抛出异常</pre>
</div>
<hr />
<h2>生产者消费者模型：</h2>
<p>正常情况下，一般都是生产者预先生产出商品，然后等着消费者来买。</p>
<p>（实际情况可能是有多个生产者，多个消费者）</p>
<div>
<pre class="prettyprint linenums">from multiprocessing import Process, JoinableQueue<br />
import time, os

def producer(q, name):<br />
    for i in range():<br />
        time.sleep()<br />
        res = '%s%s' % (name, i)<br />
        q.put(res)<br />
        print('\033[45m&lt;%s&gt; 生产了 [%s]\033[0m' % (os.getpid(), res))<br />
    q.join()　　#对应下边的task_done

def consumer(q):<br />
    while True:<br />
        res = q.get()<br />
        time.sleep(1.5)<br />
        print('\033[34m&lt;%s&gt; 吃了 [%s]\033[0m' % (os.getpid(), res))<br />
        q.task_done()    #代表我这个进程我已经取走了，发给生产者，对应生产者要有个jion（）

if __name__ == '__main__':<br />
    q = JoinableQueue()

    # 生产者们：即厨师们<br />
    p1 = Process(target=producer, args=(q, '包子'))<br />
    p2 = Process(target=producer, args=(q, '饺子'))<br />
    p3 = Process(target=producer, args=(q, '馄饨'))

    # 消费者们：即吃货们<br />
    c1 = Process(target=consumer, args=(q,))<br />
    c2 = Process(target=consumer, args=(q,))

    c1.daemon=True    #如果消费者不取完的话，程序无法结束<br />
    c2.daemon=True　　 #这里主进程运行完，子进程要结束掉<br />
    p1.start()<br />
    p2.start()<br />
    p3.start()<br />
    c1.start()<br />
    c2.start()

    p1.join()

    print('主')</pre>
</div>
<hr />
<h2>进程池：</h2>
<div>
<pre class="prettyprint linenums"> from multiprocessing import Pool<br />
 import os,time

 def work(n):<br />
     print('task &lt;%s&gt; is runing' %os.getpid())<br />
     time.sleep(2)<br />
     return n**2<br />
 if __name__ == '__main__':<br />
     # print(os.cpu_count())<br />
     p=Pool(4)    #定义进程池的大小，如果不定义一般是内核数<br />
     # for i in range(10):<br />
     #     res=p.apply(work,args=(i,))    #向进程池里边添加进程，同步提交<br />
     #     print(res)

     res_l=[]<br />
     for i in range(10):<br />
         res=p.apply_async(work,args=(i,))    #向进程池异步提交，只管扔进去，不管是否执行完成<br />
         res_l.append(res)

     p.close()<br />
     p.join()<br />
     #<br />
     # for res in res_l:<br />
     #     print(res.get())</pre>
</div>
<h2>进程池之回调函数：</h2>
<p><strong>需要回调函数的场景，进程池中任何一个任务一旦处理完成，就立即告诉主进程，我好了，你可以处理我的结果了，主进程调用一个函数去处理该结果，该函数即回调函数。</strong></p>
<div>
<pre class="prettyprint linenums"> import requests #pip3 install requests<br />
 import os,time<br />
 from multiprocessing import Pool<br />
 def get_page(url):<br />
     print('&lt;%s&gt; get :%s' %(os.getpid(),url))<br />
     respone = requests.get(url)<br />
     if respone.status_code == 200:<br />
         return {'url':url,'text':respone.text}

 def parse_page(dic):<br />
     print('&lt;%s&gt; parse :%s' %(os.getpid(),dic['url']))<br />
     time.sleep(0.5)<br />
     res='url:%s size:%s\n' %(dic['url'],len(dic['text'])) #模拟解析网页内容<br />
     with open('db.txt','a') as f:<br />
         f.write(res)

 if __name__ == '__main__':<br />
     p=Pool(4)<br />
     urls = [<br />
         'http://www.baidu.com',<br />
         'http://www.baidu.com',<br />
         'http://www.baidu.com',<br />
         'http://www.baidu.com',<br />
         'http://www.baidu.com',<br />
         'http://www.baidu.com',<br />
         'http://www.baidu.com',<br />
     ]

     for url in urls:<br />
         p.apply_async(get_page,args=(url,),callback=parse_page)

     p.close()<br />
     p.join()<br />
     print('主进程pid:',os.getpid())</pre>
</div>
<hr />
<h2>paramike模块：</h2>
<p>paramike模块是一个用作做远程控制的模块，使用该模块可以对远程服务器进行命令或者文件操作。值得一提的是，fabric和ansible内部的远程管理就是使用的paramike模块。</p>
<p>#需要下载安装</p>
<p>#pip3 install paramiko</p>
<p>远程连接功能：</p>
<div>
<pre class="prettyprint linenums"> import paramiko

 # 创建SSH对象<br />
 ssh = paramiko.SSHClient()<br />
 # 允许连接不在know_hosts文件中的主机<br />
 ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())<br />
 # 连接服务器<br />
 ssh.connect(hostname='120.92.84.249', port=22, username='root', password='123QWEasd')

 # 执行命令<br />
 stdin, stdout, stderr = ssh.exec_command('df')<br />
 # 获取命令结果<br />
 result = stdout.read()<br />
 print(result.decode('utf-8'))<br />
 # 关闭连接<br />
 ssh.close()</pre>
</div>
<p>这是基于账号密码来访问客户端的。</p>
<p>另外一种方式是基于秘钥的，</p>
<p>现在服务端制作一个秘钥，ssh-keygen制作秘钥，sz可以下载到window桌面。</p>
<p>客户端要用，肯定要基于服务端有认证文件,利用 ssh-copy-id -i 用户@ip</p>
<div>
<pre class="prettyprint linenums"> import paramiko

 private_key = paramiko.RSAKey.from_private_key_file('id_rsa')   #秘钥的文件位置

 # 创建SSH对象<br />
 ssh = paramiko.SSHClient()<br />
 # 允许连接不在know_hosts文件中的主机<br />
 ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())<br />
 # 连接服务器<br />
 ssh.connect(hostname='120.92.84.249', port=22, username='root', pkey=private_key)

 # 执行命令<br />
 stdin, stdout, stderr = ssh.exec_command('df')<br />
 # 获取命令结果<br />
 result = stdout.read()<br />
 print(result.decode('utf-8'))<br />
 # 关闭连接<br />
 ssh.close()</pre>
</div>
<p>上传下载：</p>
<div>
<pre class="prettyprint linenums"> import paramiko

 transport = paramiko.Transport(('120.92.84.249', 22))<br />
 transport.connect(username='root', password='123QWEasd')

 sftp = paramiko.SFTPClient.from_transport(transport)<br />
 # 将location.py 上传至服务器 /tmp/test.py<br />
 sftp.put('id_rsa', '/tmp/test.rsa')<br />
 # 将remove_path 下载到本地 local_path<br />
 # sftp.get('remove_path', 'local_path')

 transport.close()</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqdeemv9.html">非RootLayer的隐式动画</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxko1e8.html">如何做JS 单体模式的设计----&amp;gt&semi;&amp;gt&semi;js设计模式&amp;lt&semi;&amp;lt&semi;-------单体模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oj3zxq.html">转：大神提出来的java服务器方面面试问题（当作自己的学习目标平时得多注意）</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1geyzq.html">OTG 接口烧写最小Linux的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1y20m9.html">主机控制器接口（HCI）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xmy508.html">应用apache FileUtils把网页另存为文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd43wjq.html">windows server 2008 支持 &period;net framework 4&period;0</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zo0w09.html">Junit4拓展工具JCategory与Testng的Group功能比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m7orn8.html">USB中CDC-ECM的了解和配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkd2pe8.html">c&num;   自定义数据类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jkpeo8.html">JS面向对象基础1</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p7l5n8.html">IOS开发－OC学习－kvc&comma;kvo</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gekoo08.html">centos6&period;8 安装gitlab记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpyvz0q.html">java8 日期时间之间的关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wwxlzq.html">golang中数组指针和指针数组的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jjkvnq.html">JSON Web Token（JWT）原理和用法介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25owovq.html">尚硅谷springboot学习12-profile</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r06k68.html">stark组件之分页【模仿Django的admin】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjywp39.html">&period;net 技术地图</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o4zgg8.html">Python之路&lpar;第二篇&rpar;：Python基本数据类型字符串（一）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qy13m52q.html">Log file location for Oracle E-Business Suite R12</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z1rke9.html">iOS开发之八：UISlider、UISegmentedControl、UIPageControl的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kxek49.html">JSP标签JSTL&lpar;4&rpar;--URL</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnje3w38.html">Linux的sort命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj0y6x9.html">采购申请  POCIRM-001：ORA-01403&colon; 未找到任何数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m5wln8.html">Java Web 高性能开发，第 2 部分&colon; 前端的高性能</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkg0rv8.html">Android解析中国天气接口JSon数据，应用于天气查询！</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gev1l78.html">认证模式之Spnego模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjmdzl8.html">Property属性&comma;&amp;amp&semi;nbsp&semi;KVC键值编码OC&hellip;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jljxl8.html">&lpar;NO&period;00002&rpar;iOS游戏精灵战争雏形&lpar;二&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
